//+------------------------------------------------------------------+
//|                                                          Xma.mq4 |
//|                                 Copyright  2009, XrustSolution. |
//|                                        http://www.xrust.ucoz.net |
//-------------------------------------------------------------------+
#property copyright "#Copyright  2008, XrustSolution.#"
#property link      "#http://www.xrust.ucoz.net#"

//    

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Yellow
#property indicator_color3 Yellow
#property indicator_color4 Yellow

extern double  porog =5.0;
//---- buffers
double Signal[];
double UP[];
double DN[];
double Midle[];
//+------------------------------------------------------------------+
void init(){
   IndicatorShortName("Xma("+DoubleToStr(porog,2)+")");
   SetIndexStyle(0,DRAW_LINE); SetIndexDrawBegin(0,0); SetIndexBuffer(0,Signal); SetIndexLabel(0,"Signal");
   SetIndexStyle(1,DRAW_LINE); SetIndexDrawBegin(1,0); SetIndexBuffer(1,UP);     SetIndexLabel(1,"High");
   SetIndexStyle(2,DRAW_LINE); SetIndexDrawBegin(2,0); SetIndexBuffer(2,DN);     SetIndexLabel(2,"Low");
   SetIndexStyle(3,DRAW_LINE); SetIndexDrawBegin(3,0); SetIndexBuffer(3,Midle);  SetIndexLabel(3,"Mediana");
   
   return;
} 
int deinit(){
   Comment("");
   return(0);
}
//+------------------------------------------------------------------+
int start() {
   int limit, trend;
   double tmp, tmpCandle, Price;
   int counted_bars=IndicatorCounted();
   int i;
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
  for (i=limit;i>=0;i--) {
      if (Signal[i+1]==0) {Signal[i]=(High[i]+Low[i])/2.0; continue;} 
      UP[i]=UP[i+1];
      DN[i]=DN[i+1];
      Midle[i]=Midle[i+1];
      Signal[i]=Signal[i+1];
      tmpCandle=500.0*(High[i]-Low[i])/Signal[i];
      if (tmpCandle>porog) {Signal[i]=(High[i]+Low[i])/2.0; continue; }
      
      trend=0;
      Price=Close[i];
      if (MathAbs(High[i]-Signal[i])>MathAbs(Price-Signal[i])) Price=High[i];
      if (MathAbs(Low[i]-Signal[i])>MathAbs(Price-Signal[i])) Price=Low[i];
         
      if (MathAbs(Price-Signal[i])/Signal[i]*1000.0>porog) {
         if (Price>Signal[i]) trend= 1;
         if (Price<Signal[i]) trend=-1;
         Signal[i]=1000.0/(1000.0+trend*porog)*Price;
         tmpCandle=MathAbs(Signal[i]- 1000.0/(1000.0-trend*porog)*Price);
         if(High[i]>UP[i]) {
            UP[i]=High[i];
            DN[i]=High[i]-2*tmpCandle;
         } else if (Low[i]<DN[i]){
            DN[i]= Low[i];
            UP[i]=Low[i]+2*tmpCandle;
            
         }
         Midle[i]=(UP[i]+DN[i])/2.0;
         Comment(" =", MathRound((UP[i]-DN[i])/Point));
      }
   }
   return(0);
}
//+------------------------------------------------------------------+   


